/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */

// This script includes the RESTful API for serving files under app/widgets 
// directory. Assumes URL contains the name of the file to be served as 
// a parameter.
//


import zero.core.fileserver.FileServer
import zero.core.utils.VDirectory


class statics {
    public static APP_WIDGETS_DIR = "app/iwidgets" 
}

//
// getTarget() returns the physical file or directory represented by the 
// request path using virtualized directory. 
// If the target does not exist, the method returns null.
//
def getTarget()
{
    def fileRelativePath = statics.APP_WIDGETS_DIR;
    
    if (event.pathInfo[] != null) fileRelativePath = fileRelativePath + event.pathInfo[];
    return VDirectory.getVFile(fileRelativePath);
}


//
// renderFile() returns the file's contents to the client.
//  
def renderFile(file)
{
    event.path = file.canonicalPath
    def server = new FileServer()
    server.onGET()
}

// REST API

/**
 *
 * @success 200 Returns the contents of the file.
 * @error 404 If the file or directory does not exist.
 * @format any content type
 * 
 */
def onGET()
{
    def target = getTarget()    
    
    if (target == null || !target.exists())
    {
        request.status = 404
        return
    }    
    renderFile(target)
}


